
var header_spy_options_panel = {
    update: function() {
        var i = document.getElementById("header-spy-radio-headers").selectedIndex;

        var hr_request  = document.getElementById("header-spy-headerselect-request");
        var hr_response = document.getElementById("header-spy-headerselect-response");
        var hr_header   = document.getElementById("header-spy-header");

        hr_request.disabled = (i != 0);
        hr_response.disabled = !hr_request.disabled;
        hr_header.disabled = (hr_request.disabled && hr_response.value != "9999")
            || (hr_response.disabled && hr_request.value != "9999");
    },

    load: function() {
        var p = window.arguments[0];
        var opt = window.arguments[1];

        document.getElementById("header-spy-maxwidth").value = p.max_width;
        document.getElementById("header-spy-header-ifexist").checked = p.show_if_exist;
        document.getElementById("header-spy-header-showname").checked = p.show_name;

        document.getElementById("header-spy-radio-headers").selectedIndex = p.headersrc;

        var lst = document.getElementById("header-spy-headerselect-" + (p.headersrc == 0 ? "request" : "response"));
        var items = lst.firstChild.childNodes;
        for (i = 0 ; i < items.length && items[i].label != p.header ; i++);
        if (i < items.length) { // found
            lst.selectedItem = items[i];
        } else { // not found
            document.getElementById("header-spy-header").value = p.header;

            for (i = 0 ; i < items.length && items[i].value != "9999" ; i++); // select "other"
            if (i < items.length) { // found
                lst.selectedItem = items[i];
            }
        }

        // ---
        
        document.getElementById("header-spy-popup-headers-request").value   = p.popup_headers.request;
        document.getElementById("header-spy-popup-headers-response").value  = p.popup_headers.response;
        document.getElementById("header-spy-popup-headers-wrapon").value    = p.popup_headers.wrap_on;
        document.getElementById("header-spy-popup-headers-ifexist").checked = p.popup_headers.show_if_exist;
        document.getElementById("header-spy-popup-headers-intooltip").checked = p.popup_headers.in_tooltip;
        document.getElementById("header-spy-popup-headers-inmenu").checked  = p.popup_headers.in_menu;

        // ---
        
        opt.saved = false; // mark "Don't save". Also see this.save()
        this.update();
    },

    save: function() {
        var p   = window.arguments[0];
        var opt = window.arguments[1];

        p.max_width      = document.getElementById("header-spy-maxwidth").value;
        p.show_if_exist = document.getElementById("header-spy-header-ifexist").checked;
        p.show_name    = document.getElementById("header-spy-header-showname").checked;

        p.headersrc = document.getElementById("header-spy-radio-headers").selectedIndex;

        var hr = document.getElementById("header-spy-headerselect-" + (0 == p.headersrc ? "request" : "response"));
        p.header = (hr.value != "9999" ? hr.label : document.getElementById("header-spy-header").value);

        // ---
        
        p.popup_headers.request        = document.getElementById("header-spy-popup-headers-request").value;
        p.popup_headers.response       = document.getElementById("header-spy-popup-headers-response").value;
        p.popup_headers.wrap_on        = document.getElementById("header-spy-popup-headers-wrapon").value;
        p.popup_headers.show_if_exist  = document.getElementById("header-spy-popup-headers-ifexist").checked;
        p.popup_headers.in_tooltip     = document.getElementById("header-spy-popup-headers-intooltip").checked;
        p.popup_headers.in_menu        = document.getElementById("header-spy-popup-headers-inmenu").checked;

        opt.saved = true;
        return true;
    }
};